#include <string>
#include <iostream>
#include <pthread.h>
#include <fstream>
#include <vector>
#include <semaphore.h>
#include <unistd.h>

#define STRING	std::string
#define CIN	std::cin
#define COUT	std::cout
#define ENDL	std::endl
#define VECTOR	std::vector<int>

const int reindeer_count = 9;
const int elf_count = 3;

const int reindeer_iteration = 2;
const int elf_iteration = 2;
const int santa_iteration = 4;

pthread_mutex_t hut_mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t cattle_mutex = PTHREAD_MUTEX_INITIALIZER;
VECTOR hut;
int cattle = 0;
sem_t reinder_sem[reindeer_count];
sem_t elf_sem[elf_count];
sem_t santa_sem;

int temp_reindeer[reindeer_count];
int temp_elf[elf_count];

std::ofstream logfile;

void *reindeer(void *parameter)
{
	int i = *(int *)parameter;

	for(int j = 0; j < reindeer_iteration; j++)
	{
		logfile << "Reindeer# " << i << ": Sanat I'm ready" << ENDL;
		
		pthread_mutex_lock(&cattle_mutex);//{

		cattle++;

		if(cattle == 9)
		{
			logfile << "Reindeer: I'm the ninth reindeer WAKE UP Sanat!" << ENDL;
			sem_post (&santa_sem);
		}
	
		pthread_mutex_unlock(&cattle_mutex);//}

		sem_wait (&reinder_sem[i]);

		logfile << "Reindeer# " << i << ": I'm going to have some fun" << ENDL;
		usleep(1000);
	}

	return NULL;
}

void *elf(void *parameter)
{
	int i = *(int *)parameter;
	
	for(int j = 0; j < elf_iteration; j++)
	{
		logfile << "Elf# " << i << ": Sanat can I have a word with you?" << ENDL;

		pthread_mutex_lock(&hut_mutex);//{

		hut.push_back(i);

		if(hut.size() == 3)
		{
			logfile << "Elf: I'm the third elf WAKE UP Sanat!" << ENDL;	
			sem_post (&santa_sem);
		}
	
		pthread_mutex_unlock(&hut_mutex);//}

		sem_wait (&elf_sem[i]);
		
		logfile << "Elf# " << i << ": I'm going out" << ENDL;
	}

	return NULL;
}

void *santa(void *parameter)
{
	for(int i = 0; i < santa_iteration; i++)
	{
		sem_wait (&santa_sem);
		logfile << "Santa: HAWWW" << ENDL;
		
		pthread_mutex_lock(&cattle_mutex);//{

		if(cattle == 9)
		{
			logfile << "Santa: My indeers we have lots of works to do" << ENDL;
			cattle = 0;
			
			for(int j = 0; j < reindeer_count; j++)
				logfile << "Santa: Reindeer# " << j << " has harnessed" << ENDL;

			logfile << "Santa: We are going to journey" << ENDL;
			usleep(1000);
			logfile << "Santa: We are back" << ENDL;
			
			for(int j = 0; j < reindeer_count; j++)
			{
				logfile << "Santa: Reindeer# " << j << " has unharnessed" << ENDL;
				sem_post (&reinder_sem[j]);
			}
			
			pthread_mutex_unlock(&cattle_mutex);//}
		}
		else
		{		
			pthread_mutex_unlock(&cattle_mutex);//}
			
			pthread_mutex_lock(&hut_mutex);//{

			logfile << "Santa: Dear elves I'm listening to your words" << ENDL;
				
			for(int j = 0; j < hut.size(); j++)
				logfile << "Santa: Reindeer# " << hut[j] << " what's your idea" << ENDL;

			logfile << "Santa: We are begining session" << ENDL;
			usleep(1000);
			logfile << "Santa: Well done" << ENDL;
			
			for(int j = 0; j < hut.size(); j++)
			{
				logfile << "Santa: Elf# " << hut[j] << " that's the way" << ENDL;
				sem_post (&elf_sem[hut[j]]);
			}

			hut.resize(0);
		
			pthread_mutex_unlock(&hut_mutex);//}		
		}
	
	}
	return NULL;
}

int main()
{
	logfile.open("logfile");
	
	for(int i = 0; i < reindeer_count; i++)
	{
		sem_init (&reinder_sem[i], 0, 0);
		temp_reindeer[i] = i;
	}
	
	for(int i = 0; i < elf_count; i++)
	{
		sem_init (&elf_sem[i], 0, 0);
		temp_elf[i] = i;
	}

	sem_init (&santa_sem, 0, 0);
	
	pthread_t reinders[reindeer_count];
	pthread_t elves[elf_count];
	pthread_t the_santa;

	for(int i = 0; i < reindeer_count; i++)
	{
		pthread_create(&reinders[i], NULL, &reindeer, &temp_reindeer[i]);
		logfile << "! The reindeer# " << i << " has been created" << ENDL;
	}

	for(int i = 0; i < elf_count; i++)
	{
		pthread_create(&elves[i], NULL, &elf, &temp_elf[i]);
		logfile << "! The elf# " << i << " has been created" << ENDL;
	}

	pthread_create(&the_santa, NULL, &santa, NULL);
	logfile << "! The santa has been created" << ENDL;	

	for(int i = 0; i < reindeer_count; i++)
	{
		pthread_join(reinders[i], NULL);
		logfile << "! The reindeer# " << i << " has been gone" << ENDL;
	}

	for(int i = 0; i < elf_count; i++)
	{
		pthread_join(elves[i], NULL);
		logfile << "! The elf# " << i << " has been gone" << ENDL;
	}
	
	pthread_join(the_santa, NULL);
	logfile << "! The santa has been gone" << ENDL;

	logfile.close();
	return 0;
}


